import numpy as np
import matplotlib
matplotlib.use("qt5agg")
from matplotlib import pyplot as plt
from scipy import interpolate
from PyQt5 import QtCore, QtWidgets
import time as tm
def largest_amplitude():
    #amplitude = np.empty(0)
    #amplitude = np.sort((fft.real),axis=0)[0:10][::2]
    #x = [[0,1],[0,1],[0,1],[0,1],[0,1]]
    x = [[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18],
         [0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18],
         [0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18],
         [0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18],
         [0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18]]
    return(x)

#TODO: USE HUBTIME, USE ANGLE 0., FIX Y and X axis. Use predicitor. 
angle_names =[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18]
my_xticks = ['Hips','Left Upper Leg','Right Upper Leg','Left Lower Leg',
             'Right Lower Leg','Left Foot','Right Foot','Spine','Chest','Neck',
             'Head','Left Shoulder','Right Shoulder','Left Upper Arm','Right Upper Arm',
             'Left Lower Arm','Right Lower Arm','Left Hand','Right Hand']

#SVM goes here



input_time = np.zeros(0)
sample_time = 15
number_of_angles = 2# true value = 19
x= np.zeros(number_of_angles)
angle = np.zeros(number_of_angles)

i=0;
input()
plt.ion()

while(True):
    tm.sleep(0.002)
    # do frame calculation here
    value = input()
    values = value.split(',')
    time = float(values[0])
    for k in range(number_of_angles):
        angle[k] = float(values[k+1])
    angle = np.asarray(angle)
    if(i==0):
        time_0 = float(values[0])
    i +=1
    try:
        if(i<=sample_time):
            x = np.vstack([x,angle])
            input_time = np.append(input_time,time)
            input_time[i-1]=input_time[i-1]-time_0
            x_fft = []
            if(i==1):
                x = np.delete(x,0,0)

                amplitude = largest_amplitude()
            if(i>3):       # Cubic => k = 3. 
                y_hat= interpolate.UnivariateSpline(input_time,x[:,k].ravel())             
                for k in range(number_of_angles):
                    furrier_input = y_hat(input_time)
                    furrier_input = furrier_input - np.mean(furrier_input)
                    x_fft.append(np.abs(np.fft.fft(furrier_input, norm = 'ortho')))
                #plotting
                plt.figure(1)
                plt.subplot(311)
                for k in range(number_of_angles):
                    plt.plot(input_time, x[:,k].ravel(), '-')
                    plt.plot(y_hat(input_time),'--')   
                plt.subplot(312)
                for k in range(number_of_angles):
                    plt.plot(x_fft[k], '-')            
                plt.subplot(313)
                plt.xticks(angle_names,my_xticks,rotation='vertical') 
                plt.ylabel('Top 5 Frequencies')
                for k in range(5):
                    plt.plot(angle_names,(np.subtract(amplitude[k],k/2)), '.')
             
                plt.show() #Only for testing in spyder1
                plt.waitforbuttonpress(0.01)
        if(i>sample_time):
            x = np.append(x,values[1])
            x_mean = np.mean(x)
            input_time = np.append(input_time,time)
            x_fft = np.abs(np.fft.fft(x-x_mean, norm = 'ortho'))
            amplitude = largest_amplitude()
            #Plotting
            plt.clf()
            plt.figure(1)
            plt.subplot(311)
            plt.plot(input_time[0:i], x[0:i], 'r-')
            plt.pause(0.0001)        
            plt.subplot(312)
            plt.subplot(313)
            plt.xticks(angle_names,my_xticks,rotation='vertical') 
            plt.ylabel('Top 5 Frequencies')

            plt.show() #Only for testing in spyder
            plt.waitforbuttonpress(0.01)

    except Exception:
        print("can't handle " + str(value))


    #Skriv noget kode der ryder op i memory, np.delete på både x og tid. 
    except KeyboardInterrupt:
        pass



# class Thread(QtCore.QThread):
#     def __init__(self):
#         QtCore.QThread.__init__(self)

#     def run(self):
#         thread_func()
#         self.exec_()

# def thread_func():
#     refresh_timer = QtCore.QTimer()
#     refresh_timer.timeout.connect(update_function)
#     refresh_timer.start( 1.0 / 30 ) # have update_function called at 30Hz


# while (True):
#     update_function()

# import sys
# app = QtWidgets.QApplication(sys.argv)
# thread_instance = Thread()
# thread_instance.start()
# sys.exit(app.exec_())

#try:
